/* eslint-disable react-native/no-inline-styles */
import React, { memo } from 'react';
import { View, StyleSheet, Text } from 'react-native';
import { Checkbox } from 'react-native-paper';

const CheckboxInput = ({
  isChecked,
  label,
  checkboxColor,
  checkboxLabelStyle,
  checkboxUncheckedColor
}) => /*#__PURE__*/React.createElement(View, {
  style: styles.container
}, /*#__PURE__*/React.createElement(Checkbox.Android, {
  uncheckedColor: checkboxUncheckedColor || '#000007',
  color: checkboxColor || 'blue',
  status: isChecked === true ? 'checked' : 'unchecked',
  style: {
    flex: 1
  }
}), /*#__PURE__*/React.createElement(Text, {
  style: { ...checkboxLabelStyle,
    flexDirection: 'row',
    flexShrink: 1
  }
}, label.trim()));

const styles = StyleSheet.create({
  container: {
    flexDirection: 'row',
    alignItems: 'center',
    flex: 1,
    marginBottom: 1.5
  }
});
export default /*#__PURE__*/memo(CheckboxInput);
//# sourceMappingURL=checkBox.js.map